
	-----------------------
	-- smaltore@live.com --
	-----------------------
	
--## config start ##--

-- all scale/整体比例
local SCALE = 0.85

-- height of watch bars / 声望等监控条高度
local HEIGHT = 4

-- adjust side bars y position/右侧动作条的垂直位置
local SIDEBAR_Y = 0

-- fade side bars/渐隐右侧动作条
local SIDEBAR_FADE = true 

-- fade micro buttons and bags/渐隐背包动作条
local MICRO_BAGS_FADE = true

--## config end ##--


MainMenuBar:SetScale(SCALE)
MainMenuBar:SetWidth(512);
-----------------------------------
--## hide the artwork from blz ##--

for _, texture in next, {

	MainMenuBarLeftEndCap,MainMenuBarRightEndCap,
	MainMenuBarPageNumber,ActionBarUpButton,ActionBarDownButton,
	MainMenuBarTexture0,MainMenuBarTexture1,MainMenuBarTexture2,MainMenuBarTexture3,
	MainMenuXPBarTexture0, MainMenuXPBarTexture1, MainMenuXPBarTexture2, MainMenuXPBarTexture3, 
	MainMenuMaxLevelBar0, MainMenuMaxLevelBar1, MainMenuMaxLevelBar2, MainMenuMaxLevelBar3, 
	MainMenuBarTexture0, MainMenuBarTexture1, MainMenuBarTexture2, MainMenuBarTexture3,
	ReputationWatchBarTexture0, ReputationWatchBarTexture1, ReputationWatchBarTexture2, ReputationWatchBarTexture3, 
	ReputationXPBarTexture0, ReputationXPBarTexture1, ReputationXPBarTexture2, ReputationXPBarTexture3,
	BonusActionBarTexture0, BonusActionBarTexture1, 
	ShapeshiftBarLeft, ShapeshiftBarMiddle, ShapeshiftBarRight, 
	PossessBackground1, PossessBackground2,
	SlidingActionBarTexture0, SlidingActionBarTexture1,
} do
	texture:Hide();
end

MultiBarBottomRightButton1:ClearAllPoints()
MultiBarBottomRightButton1:SetPoint("BOTTOMLEFT", MultiBarBottomLeftButton1, 'TOPLEFT', 0, 7);


-- set the blank area unclickable, in order to make the other addons work
for _, bar in next, {
	MainMenuBar,
	MultiBarBottomLeft, 
	MultiBarBottomRight, 
	MultiBarLeft, 
	MultiBarRight, 
	PetActionBarFrame, 
	PossessBarFrame, 
	StanceBarFrame 
	} do 
	bar:EnableMouse(false);
end 


----------------------
--## layout my bars --

local function obar_layout()
	
	if InCombatLockdown() then return end
		
	if SIDEBAR_Y ~= 0  then
		MultiBarRightButton1:ClearAllPoints()
		MultiBarRightButton1:SetPoint("TOPRIGHT", MultiBarRight,"TOPRIGHT", -2 , -3 + SIDEBAR_Y) 
		MultiBarLeftButton1:ClearAllPoints()
		MultiBarLeftButton1:SetPoint("TOPRIGHT", MultiBarLeft, "TOPRIGHT", -2, -3+SIDEBAR_Y) 
	end

	local petx,pety																
	if (not SHOW_MULTI_ACTIONBAR_1 and  not SHOW_MULTI_ACTIONBAR_2 ) then 		-- show bar 1 only
		pety = 0
	elseif ( SHOW_MULTI_ACTIONBAR_1 and not SHOW_MULTI_ACTIONBAR_2 ) then 		-- show BL only; what about show BR only, joy me?
		pety = 36 + 6    	-- bar2 button height is 36 & gap is 8
	else																		-- show BL&BR
		pety = (36+6) * 2
	end
	
	if ( StanceBarFrame and GetNumShapeshiftForms() > 0 )  then petx = 127 else petx = 127/2  end 		--set PetBar right when StanceBar  
	PetActionButton1:ClearAllPoints()
	PetActionButton1:SetPoint("BOTTOMLEFT", MultiBarBottomLeftButton1, "BOTTOMLEFT", petx, pety)

	StanceButton1:ClearAllPoints()
	StanceButton1:SetPoint("BOTTOMLEFT", MultiBarBottomLeftButton1, "BOTTOMLEFT", 0, pety)
	MainMenuBarVehicleLeaveButton:ClearAllPoints()
	MainMenuBarVehicleLeaveButton:SetPoint("BOTTOMRIGHT", MultiBarBottomLeftButton12, "BOTTOMRIGHT", 0, pety + 30 + 6)    --higher than pet button
	
	--hide the background of stancebar when actionbar1 only
	for i = 1, NUM_STANCE_SLOTS do
		if _G["StanceButton"..i]:GetNormalTexture():GetWidth() ~= 52 then
			_G["StanceButton"..i]:GetNormalTexture():SetWidth(52)
			_G["StanceButton"..i]:GetNormalTexture():SetHeight(52)
		end
	end
 end
hooksecurefunc("UIParent_ManageFramePositions",  obar_layout)
 
----------------------------------------- 
-- ## micro buttons and bags ##--
local MicroButtonAndBagsBar = CreateFrame('frame', obar_bags_mbuttons, UIParent)
MicroButtonAndBagsBar:SetSize(100, 100)
MicroButtonAndBagsBar:SetPoint("BOTTOMRIGHT")
MicroButtonAndBagsBar:SetScale(SCALE * 0.75)

hooksecurefunc("UpdateMicroButtons",function()
	--small bags
	for i= 0, 3 do
		_G[ "CharacterBag"..i.."Slot" ]:SetParent(MicroButtonAndBagsBar) 
		_G[ "CharacterBag"..i.."Slot" ]:Hide() 
	end
	MainMenuBarBackpackButton:SetParent(MicroButtonAndBagsBar) 
	MainMenuBarBackpackButton:SetScale( 1.8 )
	MainMenuBarBackpackButton:ClearAllPoints()
	MainMenuBarBackpackButton:SetPoint("BOTTOMRIGHT", MicroButtonAndBagsBar, 0, 2)

	-- micro menu bar
	UpdateMicroButtonsParent(MicroButtonAndBagsBar)
	local m = math.floor( (#MICRO_BUTTONS + 1)/2 ) 	-- calculate the last button number of first line
	_G[ MICRO_BUTTONS[1] ]:ClearAllPoints()   			--MICRO_BUTTONS is a name table of buttons, here transform to button by _G
	_G[ MICRO_BUTTONS[1] ]:SetPoint("BOTTOMLEFT", MainMenuBarBackpackButton, -30 * m +5, 32)
	_G[ MICRO_BUTTONS[m+1] ]:ClearAllPoints()
	_G[ MICRO_BUTTONS[m+1] ]:SetPoint("TOP", _G[ MICRO_BUTTONS[1] ] , "BOTTOM", 0, 22);
	--MainMenuBarPerformanceBar:Hide(); -- hide the delay bar under the MainMenuMicroButton
end)

MainMenuBarPerformanceBar:SetSize(8,95)
MainMenuBarPerformanceBarFrame:SetParent(MicroButtonAndBagsBar) 
MainMenuBarPerformanceBarFrame:ClearAllPoints()
MainMenuBarPerformanceBarFrame:SetPoint("TOPRIGHT", MainMenuBarBackpackButton, 'TOPLEFT', 0, 20)

---------------------------------
--## exp & rep & hornor bars ##--
for _,bar in next, {MainMenuExpBar, MainMenuBarMaxLevelBar, ReputationWatchBar, ReputationWatchBar.StatusBar,}  do bar:SetWidth(500) end

MainMenuExpBar:SetHeight(HEIGHT)
ExhaustionLevelFillBar:SetHeight(HEIGHT) 

function MainMenuTrackingBar_Configure(frame, isOnTop)
	local statusBar = frame.StatusBar;
	statusBar:SetFrameLevel(MainMenuBarArtFrame:GetFrameLevel()-1);	
	if ( isOnTop ) then
		statusBar:SetHeight(HEIGHT);
		frame:ClearAllPoints();
		frame:SetPoint("BOTTOM", MainMenuBar, "TOP", 0, -3);
		frame.OverlayFrame.Text:SetPoint("CENTER", frame.OverlayFrame, "CENTER", 0, 3);
	else
		statusBar:SetHeight(HEIGHT+2);
		frame:ClearAllPoints();
		frame:SetPoint("TOP", MainMenuBar, "TOP", 0, 0);
		frame.OverlayFrame.Text:SetPoint("CENTER", frame.OverlayFrame, "CENTER", 0, 1);
	end
			
	statusBar.WatchBarTexture0:Hide();
	statusBar.WatchBarTexture1:Hide();
	statusBar.WatchBarTexture2:Hide();
	statusBar.WatchBarTexture3:Hide();
	statusBar.XPBarTexture0:Hide();
	statusBar.XPBarTexture1:Hide();
	statusBar.XPBarTexture2:Hide();
	statusBar.XPBarTexture3:Hide();	
end


--------------------------------
-- ##Fade function ## --
local obar_fade =CreateFrame("frame")
local function obar_UIFrameFade(frame, timeToFade, startAlpha, endAlpha) -- 2016-10-16:in case of frame:show() error, there create my hook function
	frame.fadeInfo = {};
	if startAlpha < endAlpha then frame.fadeInfo.mode = "IN"; else frame.fadeInfo.mode = "OUT" end
	frame.fadeInfo.timeToFade = startAlpha
	frame.fadeInfo.startAlpha = startAlpha
	frame.fadeInfo.endAlpha = endAlpha
		
	frame:SetAlpha(frame.fadeInfo.startAlpha);

	local index = 1;
	while FADEFRAMES[index] do
		-- If frame is already set to fade then return
		if ( FADEFRAMES[index] == frame ) then
			return;
		end
		index = index + 1;
	end
	tinsert(FADEFRAMES, frame);
	obar_fade:SetScript("OnUpdate", UIFrameFade_OnUpdate);
end

local function FadeFrame(frame,button)
	if not frame then return end
	frame:EnableMouse(true)
	frame:SetAlpha(0.1)
	button:HookScript("OnEnter", function() obar_UIFrameFade(frame, 0.1, 0.05, 1 ) end)   	
	button:HookScript("OnLeave", function() obar_UIFrameFade(frame, 2, 1, 0.05 )   end) 
end

--fade side bar
if SIDEBAR_FADE then
	for i = 1, 12 do 
		FadeFrame( MultiBarLeft, _G[ "MultiBarLeftButton"..i ] ) 
		FadeFrame( MultiBarRight, _G[ "MultiBarRightButton"..i ] ) 
	end
end
 --fade Micro Buttons & Bags
 if MICRO_BAGS_FADE then
	FadeFrame(MicroButtonAndBagsBar,MainMenuBarBackpackButton)
	for i= 1, #MICRO_BUTTONS  do FadeFrame(MicroButtonAndBagsBar, _G[ MICRO_BUTTONS[i] ]) end
end
